export declare class CollectionUtil {
    private constructor();
    static addToMapSet<K, T>(mapSet: Map<K, Set<T>>, addKey: K, addVal: T, kcompFunc?: (a: K, b: K) => boolean, tcompFunc?: (a: T, b: T) => boolean): void;
    static mapSetContains<K, T>(mapSet: Map<K, Set<T>>, addKey: K, addVal: T, kcompFunc?: (a: K, b: K) => boolean, tcompFunc?: (a: T, b: T) => boolean): boolean;
    static iterateSet<K, T>(mapSet: Map<K, Set<T>>, addKey: K, kcompFunc?: (a: K, b: K) => boolean): Generator<T, void, undefined>;
    static removeFromMapSet<K, T>(mapSet: Map<K, Set<T>>, removeKey: K, removeVal: T, kcompFunc?: (a: K, b: K) => boolean, tcompFunc?: (a: T, b: T) => boolean): void;
    private static removeEntry;
    private static assertMapSet;
    private static assertCompFunc;
}
