export interface IPackageJsonAuthor {
    name?: string;
    email?: string;
    url?: string;
}
export interface PackageJson {
    version: string;
    name?: string;
    description?: string;
    author?: string | IPackageJsonAuthor;
    license?: string;
    homepage?: string;
    host?: string;
    basePath?: string;
}
export declare function getPackageVersion(): string;
export declare function getPackageJsonAuthor(pkg: PackageJson): IPackageJsonAuthor | undefined;
