import { IDecorator } from "../transformer/Decorator";
import { AbstractClassConstructor, ClassConstructor1 } from "../Util/ClassConstructors";
import { IDecoratorDependency, DecoratorDependencyType, IDecoratorDefinitionBase } from "../transformer/DecoratorDefinition";
export declare function ApiDecorator<Def extends Omit<IDecoratorDefinitionBase, 'decoratorType'>, Dec extends IDecorator = IDecorator>(c: ClassConstructor1<Def, Dec>, d: Omit<Def, 'magicFunctionName'>): (target: object, propertyKey: string, descriptor: TypedPropertyDescriptor<any>) => void;
export declare function ApiMethodDecoratorGetFunction<D extends IDecorator>(baseClass: AbstractClassConstructor): (param: string | Function) => D;
export declare function DecoratorParentDependency(type: DecoratorDependencyType, value: string): IDecoratorDependency;
export declare function DecoratorParentNameDependency(value: string): IDecoratorDependency;
export declare function DecoratorParentProviderDependency(value: string): IDecoratorDependency;
export declare function DecoratorPeerDependency(type: DecoratorDependencyType, value: string): IDecoratorDependency;
