import { ClassConstructor } from "../Util/ClassConstructors";
declare abstract class DependencyParams {
    static readonly ConstructorKey: any;
    static ApiCallbackParam: any;
    static ApiDependency<T extends ClassConstructor>(constructor: T): void;
    /**
     * A dependency property
     * @param validator
     */
    static ApiInjectedDependency(scope?: string): PropertyDecorator;
    /**
     * A dependency parameter
     * @param validator
     */
    static ApiInjectedDependencyParam(scope?: string): ParameterDecorator;
}
export declare const GetDependencyParamDecorator: (param: string | Function) => import("../transformer/Decorator").IDecorator<import("typescript").Node>;
export declare const ApiDependency: typeof DependencyParams.ApiDependency;
export declare const ApiInjectedDependency: typeof DependencyParams.ApiInjectedDependency;
export declare const ApiInjectedDependencyParam: typeof DependencyParams.ApiInjectedDependencyParam;
export {};
