"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiOutParamStream = exports.GetOutParamDecorator = void 0;
const apiManagement_1 = require("../apiManagement");
const InternalTypes_1 = require("../apiManagement/InternalTypes");
const DecoratorUtil_1 = require("./DecoratorUtil");
const HandlerMethodParameterDecorator_1 = require("../transformer/HandlerMethodParameterDecorator");
const TransformerMetadata_1 = require("../transformer/TransformerMetadata");
const API_1 = require("./API");
class OutParams {
    static ApiOutParamStream(a) {
        const args = a;
        return (target, propertyKey, parameterIndex) => {
            apiManagement_1.ManagedApiInternal.AddApiHandlerParamMetadataToObject({
                ...a,
                args,
                parameterIndex,
                propertyKey,
                type: 8 /* ApiParamType.Out */,
                overrideOutput: true,
            }, target.constructor);
        };
    }
}
__decorate([
    (0, DecoratorUtil_1.ApiDecorator)(HandlerMethodParameterDecorator_1.HandlerMethodParameterDecorator, {
        indexTs: __filename,
        dependencies: [(0, DecoratorUtil_1.DecoratorParentNameDependency)(API_1.Api.name)],
        parameterType: 8 /* ApiParamType.Out */,
        parameterTypeRestrictions: [InternalTypes_1.InternalTypeUtil.TypeAnyObject],
        provider: TransformerMetadata_1.BuiltinMetadata.BuiltinComponent,
        transformArgumentsToObject: true,
        skipOutputTypeDefinitions: true,
        overrideOutput: true,
        arguments: [],
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], OutParams, "ApiOutParamStream", null);
exports.GetOutParamDecorator = (0, DecoratorUtil_1.ApiMethodDecoratorGetFunction)(OutParams);
exports.ApiOutParamStream = OutParams.ApiOutParamStream;
//# sourceMappingURL=OutParams.js.map