import { OutputFileGeneratorFunc } from './IGenerator';
export declare class OutputFileGenerator {
    static readonly IGNORE_FILE = ".tsapi-generator-ignore";
    private outFiles;
    private untouchableFiles;
    private readonly baseDir;
    constructor(baseDir: string);
    addOutputFile(filePath: string, generatorFunc: OutputFileGeneratorFunc): void;
    generate(): Promise<string[]>;
    private generateFile;
    private createPath;
    private isUntouchable;
    private loadUntouchableFiles;
    private matchPatternInOutputDir;
    private getIgnoreFilePath;
    private getDefaultEncoding;
    private clearOutputDirectory;
}
