import { IDecoratorArgument } from "./DecoratorDefinition";
export declare abstract class BuiltinArgumentExtractors {
    static readonly RouteArgument: IDecoratorArgument;
    static readonly ResponseCodesArgument: IDecoratorArgument;
    static readonly ApiProcessorStageArgument: IDecoratorArgument;
    static readonly ApiProcessorScopeArgument: IDecoratorArgument;
    static readonly NameArgument: IDecoratorArgument;
    static readonly FunctionArgumentNameArgument: IDecoratorArgument;
    static readonly SchemaOutputRefOverrideArgument: IDecoratorArgument;
    static readonly OptionalNameArgument: IDecoratorArgument;
    static readonly MimeTypeArgument: IDecoratorArgument;
    static readonly OptionalMimeTypeArgument: IDecoratorArgument;
    static readonly DependencyScopeArgument: IDecoratorArgument;
    static readonly RegexpArgument: IDecoratorArgument;
    static readonly NumberMinArgument: IDecoratorArgument;
    static readonly NumberMaxArgument: IDecoratorArgument;
    static readonly BoolUndefinedIfOmitted: IDecoratorArgument;
    static readonly ValidationFunctionArgument: IDecoratorArgument;
    static readonly ReturnSchemaArgument: IDecoratorArgument;
    static readonly DecoratorTypeArgTypeArgument: ((argNo: number) => IDecoratorArgument);
    private static GetNodeReturnType;
    private static GetTypeArgumentType;
    private static parenthesizeExpression;
    private static;
}
