"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecoratorDependencyLocation = exports.DecoratorDependencyType = exports.DecoratorNodeTreeHierarchyType = exports.DecoratorType = void 0;
var DecoratorType;
(function (DecoratorType) {
    DecoratorType[DecoratorType["Class"] = 0] = "Class";
    DecoratorType[DecoratorType["ClassProperty"] = 1] = "ClassProperty";
    DecoratorType[DecoratorType["Method"] = 2] = "Method";
    DecoratorType[DecoratorType["MethodParameter"] = 3] = "MethodParameter";
    DecoratorType[DecoratorType["Constructor"] = 4] = "Constructor";
    DecoratorType[DecoratorType["ConstructorParameter"] = 5] = "ConstructorParameter";
})(DecoratorType || (exports.DecoratorType = DecoratorType = {}));
var DecoratorNodeTreeHierarchyType;
(function (DecoratorNodeTreeHierarchyType) {
    DecoratorNodeTreeHierarchyType[DecoratorNodeTreeHierarchyType["Child"] = 0] = "Child";
    DecoratorNodeTreeHierarchyType[DecoratorNodeTreeHierarchyType["Modifier"] = 1] = "Modifier";
})(DecoratorNodeTreeHierarchyType || (exports.DecoratorNodeTreeHierarchyType = DecoratorNodeTreeHierarchyType = {}));
var DecoratorDependencyType;
(function (DecoratorDependencyType) {
    DecoratorDependencyType[DecoratorDependencyType["NameDependency"] = 0] = "NameDependency";
    DecoratorDependencyType[DecoratorDependencyType["ProviderDependency"] = 1] = "ProviderDependency";
})(DecoratorDependencyType || (exports.DecoratorDependencyType = DecoratorDependencyType = {}));
var DecoratorDependencyLocation;
(function (DecoratorDependencyLocation) {
    DecoratorDependencyLocation[DecoratorDependencyLocation["Parent"] = 0] = "Parent";
    DecoratorDependencyLocation[DecoratorDependencyLocation["Peer"] = 1] = "Peer";
})(DecoratorDependencyLocation || (exports.DecoratorDependencyLocation = DecoratorDependencyLocation = {}));
//# sourceMappingURL=DecoratorDefinition.js.map