import * as ts from 'typescript';
import { IMethodDecoratorDefinition } from './DecoratorDefinition';
import { ITransformedTreeElement, IHandlerTreeNode } from './HandlerTree';
import { ITransformContext } from './ITransformContext';
import { Decorator } from './Decorator';
export declare class HandlerMethodDecorator extends Decorator<ts.MethodDeclaration, IMethodDecoratorDefinition> implements IMethodDecoratorDefinition {
    constructor(definition: Omit<IMethodDecoratorDefinition, 'decoratorType'>);
    get returnTypeRestriction(): import("../apiManagement/InternalTypes").InternalTypeDefinition[];
    getDecoratorTreeElement(parent: IHandlerTreeNode | undefined, node: ts.MethodDeclaration, decorator: ts.Decorator, context: ITransformContext): ITransformedTreeElement<ts.Decorator>;
}
