export declare class HttpError<T extends object = {}> extends Error {
    readonly statusCode: number;
    responseBody: {
        message: string;
    } & T;
    constructor(m: string, statusCode: number, bodyContents?: T);
}
