"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpError = void 0;
class HttpError extends Error {
    constructor(m, statusCode, bodyContents = {}) {
        super(m);
        this.statusCode = statusCode;
        this.responseBody = {
            message: m,
            ...bodyContents,
        };
        // Set the prototype explicitly.
        Object.setPrototypeOf(this, HttpError.prototype);
    }
}
exports.HttpError = HttpError;
//# sourceMappingURL=HttpError.js.map