"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeneratorUtil = void 0;
const stripDirs = require("strip-dirs");
const path = require("path");
class GeneratorUtil {
    static GetTsFileOutputPath(tsconfig, tsconfigPath, file) {
        if (tsconfig && tsconfig.options && typeof tsconfig.options.outDir === 'string') {
            const baseDir = path.dirname(tsconfigPath);
            file = path.join(tsconfig.options.outDir, stripDirs(file.substr(baseDir.length + 1), 1));
        }
        return path.join(path.dirname(file), path.basename(file, path.extname(file)));
    }
    static NormalizePathSlashes(path) {
        return path.replace(/\\/g, '/');
    }
}
exports.GeneratorUtil = GeneratorUtil;
//# sourceMappingURL=GeneratorUtil.js.map