import * as ts from 'typescript';
export declare type WithSymbol<T extends object> = T & {
    symbol?: ts.Symbol;
};
export declare class TsapiSymbol implements ts.Symbol {
    flags: ts.SymbolFlags;
    escapedName: ts.__String;
    declarations: ts.Declaration[];
    valueDeclaration: ts.Declaration;
    members?: ts.SymbolTable;
    exports?: ts.SymbolTable;
    globalExports?: ts.SymbolTable;
    name: string;
    getFlags(): ts.SymbolFlags;
    getEscapedName(): ts.__String;
    getName(): string;
    getDeclarations(): ts.Declaration[];
    getDocumentationComment(typeChecker: ts.TypeChecker): ts.SymbolDisplayPart[];
    getJsDocTags(): ts.JSDocTagInfo[];
}
