import { HandlerMethodParameterDecorator } from "../transformer/HandlerMethodParameterDecorator";
declare abstract class OutParams {
    /**
     * Decorates a body parameter that receives a writable stream to which the output should be written
     */
    static ApiOutParamStream(mimeType?: string): any;
}
export declare const GetOutParamDecorator: (param: string | Function) => HandlerMethodParameterDecorator;
export declare const ApiOutParamStream: typeof OutParams.ApiOutParamStream;
export {};
