import { IDecorator, DecoratorNodeType } from "./Decorator";
import { IHandlerTreeNode } from './HandlerTree';
import { IDecoratorResolver } from './IDecoratorResolver';
export declare class DecoratorResolver implements IDecoratorResolver {
    private nodeTypeMap;
    constructor(defaultDecorators?: IDecorator[]);
    addDecorator(decorator: IDecorator): void;
    addDecorators(decorators: IDecorator[]): void;
    getDecoratorsForNodeType(type: DecoratorNodeType, parent?: IHandlerTreeNode): IDecorator[];
}
