"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HandlerCollectionDecorator = void 0;
const HandlerTree_1 = require("./HandlerTree");
const ClassDecorator_1 = require("./ClassDecorator");
class HandlerCollectionDecorator extends ClassDecorator_1.ClassDecorator {
    constructor(definition) {
        super({
            ...definition,
        }, HandlerTree_1.HandlerTreeNodeType.HandlerCollection);
    }
}
exports.HandlerCollectionDecorator = HandlerCollectionDecorator;
//# sourceMappingURL=HandlerCollectionDecorator.js.map