import * as ts from 'typescript';
import { OnApiMethodExtractedHandler } from '../ExtractionTransformer';
import { IMetadataResolver } from '../MetadataManager';
export interface IExtractionTransformerArgs {
    onApiMethodExtracted?: OnApiMethodExtractedHandler;
    metadataManager?: IMetadataResolver;
    disableOpenApiMetadata?: boolean;
}
export default function transformer(program: ts.Program, opts: IExtractionTransformerArgs): ts.TransformerFactory<ts.SourceFile>;
